// Copyright 2009 Oliver Sturm <oliver@sturmnet.org> All rights reserved. 

#light

open System

// An interface
type ICalculateArea = 
    abstract Area: unit -> float
    
// A few classes
type Point = 
    { X: float; Y: float }
    member x.Shift(dx, dy) = { x with X = x.X + dx; Y = x.Y + dy }

type Ellipse = 
    { RadiusX: float; RadiusY: float }
    interface ICalculateArea with
        member x.Area() = System.Math.PI * x.RadiusX * x.RadiusY

type Rectangle = 
    { Width: float; Height: float }
    interface ICalculateArea with
        member x.Area() = x.Width * x.Height


let rect = { Width = 30.0; Height = 15.0 }
let ellipse : Ellipse = { RadiusX = 3.0; RadiusY = 5.4 }

printfn "%f" ((rect :> ICalculateArea).Area())
printfn "%f" ((ellipse :> ICalculateArea).Area())

Console.ReadLine() |> ignore